SystemOrganization addCategory: #BrokenClasses!
SystemOrganization addCategory: #'BrokenClasses-Playground'!

ClassRefactoring subclass: #UseMethodClassRefactoring
	instanceVariableNames: 'traitCompositionString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses'!

!UseMethodClassRefactoring class methodsFor: 'as yet unclassified' stamp: 'lmn 1/15/2013 17:28:54.95'!
model: aModel class: aClass traitCompositionString: aString

	^ (self
		model: aModel
		className: aClass name)
		traitCompositionString: aString;
		yourself  ! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:07:05.214'!
categoryName

	^ self targetClass category asString! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:12:12.098'!
classVariableNames

	^ self targetClass classVariableNames join: ' '! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:26:29.252'!
initialize 

	traitCompositionString := '#()'! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:13:04.986'!
instanceVariableNames

	^ self targetClass instanceVariableNames join: ' '! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:12:42.389'!
poolDictionaries

	^ self targetClass poolDictionaryNames join: ' '! !

!UseMethodClassRefactoring methodsFor: 'preconditions' stamp: 'lmn 1/15/2013 16:37:47.695'!
preconditions
	| class |
	class := (self targetClass).
	^(RBCondition withBlock: [class notNil and: [class isMeta not]]
		errorString: class name, ' is not a valid composit class')! !

!UseMethodClassRefactoring methodsFor: 'transforming' stamp: 'lmn 1/15/2013 17:25:26.232'!
redefineClassString

	^ self targetSuperclassName, ' subclass: #', className , ' uses: ', self traitCompositionString , ' instanceVariableNames: ''', self instanceVariableNames ,''' classVariableNames:''',self classVariableNames,''' poolDictionaries:''',self poolDictionaries,''' category: ''',self categoryName,''' '! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 16:39:06.853'!
targetClass

	^ self model classNamed: className! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:08:21.306'!
targetSuperclassName

	^ self targetClass superclass name asString! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:26:17.272'!
traitCompositionString

	^ traitCompositionString! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:26:39.41'!
traitCompositionString: aString

	traitCompositionString := aString! !

!UseMethodClassRefactoring methodsFor: 'transforming' stamp: 'lmn 1/15/2013 17:25:16.831'!
transform

	self model defineClass: self redefineClassString! !

Object subclass: #BaseTrait
	instanceVariableNames: 'baseVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Playground'!

!BaseTrait methodsFor: 'as yet unclassified' stamp: 'lmn 1/15/2013 16:07:38.211'!
fastforward

	^ self! !

!BaseTrait methodsFor: 'as yet unclassified' stamp: 'lmn 1/15/2013 15:05:24.449'!
play

	baseVar := 42.
	^ 2! !

!BaseTrait methodsFor: 'as yet unclassified' stamp: 'lmn 1/15/2013 17:15:30.093'!
rewind

	^ self! !

BaseTrait subclass: #SpecialTrait
	instanceVariableNames: 'specialVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Playground'!

!SpecialTrait methodsFor: 'as yet unclassified' stamp: 'lmn 1/15/2013 14:29:10.864'!
play

	^ super play + 4! !

Object subclass: #OtherTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Playground'!

!OtherTrait methodsFor: 'as yet unclassified' stamp: 'lmn 1/15/2013 17:36:01.272'!
drive

	^ self! !

Object subclass: #TraitUser
	instanceVariableNames: 'baseVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Playground'!

!TraitUser methodsFor: 'as yet unclassified' stamp: 'lmn 1/15/2013 13:57:50.021'!
stop

	^ self! !

Dictionary subclass: #ClassUsersMap
	instanceVariableNames: ''
	classVariableNames: 'ClassUsers'
	poolDictionaries: ''
	category: 'BrokenClasses'!

!ClassUsersMap class methodsFor: 'adding' stamp: 'lmn 1/14/2013 16:18'!
at: key ifAbsentPut: aBlock 
	ClassUsers ifNil: [ClassUsers := Dictionary new].
	^ (ClassUsers at: key ifAbsentPut: aBlock)! !

!ClassUsersMap class methodsFor: 'adding' stamp: 'lmn 1/14/2013 16:12'!
at: key put: aCollection
	ClassUsers ifNil: [ClassUsers := Dictionary new].
	^ ClassUsers at: key put: aCollection! !

ORCmdClassRefactoring subclass: #ORCmdUseMethodsRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses'!

!ORCmdUseMethodsRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 16:12:55.38'!
label

	^ 'use methods'! !

!ORCmdUseMethodsRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 16:12:24.447'!
longDescription 

	^ 'Use methods of other classes in this class.'! !

!ORCmdUseMethodsRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:34:48.524'!
refactoring

	^ UseMethodClassRefactoring 
		model: self model
		class: self currentNode theNonMetaClass
		traitCompositionString: (self 
			request: 'Enter the broken class you want to include:'
			initialAnswer: 'BaseTrait')! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:47'!
+ aTrait
	"Creates a composition with the receiver and aTrait"
	aTrait traitsDo:[:t| self == t ifTrue:[TraitCompositionException
			signal: 'Trait ' , self asString, ' already in composition']].
	^TraitComposition withAll: {self}, aTrait asTraitComposition! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:47'!
- anArrayOfSelectors
	"Creates an exclusion"
	^TraitExclusion
		with: self
		exclusions: anArrayOfSelectors! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:46'!
@ anArrayOfAssociations 
	"Creates an alias"
	^TraitAlias with: self aliases: anArrayOfAssociations! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 16:30'!
addSelectorSilently: selector withMethod: compiledMethod
	super addSelectorSilently: selector withMethod: compiledMethod.
	self instanceSide noteAddedSelector: selector meta: self isMeta.
	"updateTraits of users"
	self users do: [:each | each updateTraits ]! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 15:03'!
addTraitUser: aTrait
	self users: (self users copyWith: aTrait)
! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 13:34'!
asTraitComposition
	^TraitComposition with: self! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 15:44'!
browserIcon
	"Answer an icon to be show in the browser for the receiving class."

	^ self traitComposition isEmpty ifTrue: [^#blank] ifFalse: [^#announcement]! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:31'!
classTrait

	^ ClassTrait for: self! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:40'!
copyTraitExpression

	^ self! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/15/2013 15:44:35.75'!
installInstVarsReferredIn: methods

	| allInstVars |
	allInstVars := Set new.
	methods valuesDo: [:method | allInstVars addAll: (method referredInstVars) ].
	allInstVars do: [:var | (self instVarNames includes: var) ifFalse: [
			self addInstVarName: var] ].! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/15/2013 14:59:24.488'!
installTraitsFrom: aTraitComposition
	"Install the traits from the given composition. This method implements
	the core composition method - all others are just optimizations for
	particular cases. Consequently, the optimized versions can always fall
	back to this method when things get too hairy."
	| allTraits methods |

	(self traitComposition isEmpty and: [aTraitComposition isEmpty]) ifTrue: [^self].

	"Check for cycles"
	allTraits := aTraitComposition gather: [:t | t allTraits copyWith: t].
	(allTraits includes: self) ifTrue:[^self error: 'Cyclic trait definition detected'].

	self traitComposition: aTraitComposition.
	methods := self assembleTraitMethodsFrom: aTraitComposition.
	self installInstVarsReferredIn: methods.
	self installTraitMethodDict: methods.
	self isMeta ifFalse:[self classSide updateTraitsFrom: aTraitComposition].
	
	"updateTraits of users"
	self users do: [:each | each updateTraits ].! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:49'!
isTraitTransformation
	"Polymorphic with TraitTransformation"
	^false! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/15/2013 14:35:47.178'!
notifyOfRecategorizedSelector: element from: oldCategory to: newCategory
	SystemChangeNotifier uniqueInstance selector: element recategorizedFrom: oldCategory to: newCategory inClass: self.

	"classify:under:from:trait: for all users"
	self users do: [:each | each updateTraits ]! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 15:02'!
removeTraitUser: aTrait
	self users: (self users copyWithout: aTrait).
! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:30'!
trait
	^self! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/15/2013 17:37:22.471'!
traitsDo: aBlock
	aBlock value: self.! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 16:21'!
users

	^ ClassUsersMap at: (self name asSymbol) ifAbsentPut: [^ #()]! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/15/2013 14:36:00.746'!
users: aCollection

	^ ClassUsersMap at: (self name asSymbol) put: aCollection! !
